#include "rtsa_demo_plugin.h"

void RTSA_PluginOpen(const char16_t * name, int64_t index, const char16_t * params, PluginCallback callback, void * context)
{
    int status = 0;
    int handle = 0; // handle will be used across library calls to identify the proper instances

    // perform any library initialization here

    // when done, report back to script engine using the callback
    if (status == 0) {
        callback(context, int64_t(handle), nullptr);
    } else {
        callback(context, -1, nullptr);
    }
}

void RTSA_PluginClose(int64_t handle, PluginCallback callback, void * context)
{
    // release external resources and check for errors
    if (1) {
        callback(context, 0, nullptr);
    } else {
        callback(context, -1, nullptr);
    }
}

void RTSA_PluginTerminate(int64_t handle, PluginCallback callback, void * context)
{
    // release external resources and check for errors
    if (1) {
        callback(context, 0, nullptr);
    } else {
        callback(context, -1, nullptr);
    }
}

void RTSA_PluginRead(int64_t handle, int64_t size, PluginCallback callback, void * context)
{
    // just return a list of integers 1...10
    int *buffer = nullptr;

    buffer = new int[10];
    for (int i = 0; i < 10; i++) {
        buffer[i] = i+1;
    }
    // return buffer and buffersize to script engine.
    callback(context, 10*sizeof(int), buffer);
}

void RTSA_PluginWrite(int64_t handle, int64_t size, const void * buffer, PluginCallback callback, void * context)
{
    // not implemented
    callback(context, -1, nullptr);
}

void RTSA_PluginControl(int64_t handle, const char16_t * name, int64_t size, const void * buffer, PluginCallback callback, void * context)
{
    // not implemented
    callback(context, -1, nullptr);
}

void RTSA_PluginBind(int64_t handle, const char16_t * name, PluginCallback callback, void * context)
{
    // not implemented
    callback(context, -1, nullptr);
}
