#ifndef RTSA_DEMO_PLUGIN_H
#define RTSA_DEMO_PLUGIN_H

#include "RTSA_Demo_Plugin_global.h"

#include <stdint.h>

extern "C" {

typedef void (* PluginCallback)(void * context, int64_t data, const void * buffer);

RTSA_DEMO_PLUGIN_EXPORT void RTSA_PluginOpen(const char16_t * name, int64_t index, const char16_t * params, PluginCallback callback, void * context);

RTSA_DEMO_PLUGIN_EXPORT void RTSA_PluginClose(int64_t handle, PluginCallback callback, void * context);

RTSA_DEMO_PLUGIN_EXPORT void RTSA_PluginTerminate(int64_t handle, PluginCallback callback, void * context);

RTSA_DEMO_PLUGIN_EXPORT void RTSA_PluginRead(int64_t handle, int64_t size, PluginCallback callback, void * context);

RTSA_DEMO_PLUGIN_EXPORT void RTSA_PluginWrite(int64_t handle, int64_t size, const void * buffer, PluginCallback callback, void * context);

RTSA_DEMO_PLUGIN_EXPORT void RTSA_PluginControl(int64_t handle, const char16_t * name, int64_t size, const void * buffer, PluginCallback callback, void * context);

RTSA_DEMO_PLUGIN_EXPORT void RTSA_PluginBind(int64_t handle, const char16_t * name, PluginCallback callback, void * context);

}

#endif // RTSA_DEMO_PLUGIN_H
